package com.example.soulfood_assignment2;

import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.spotify.android.appremote.api.ConnectionParams;
import com.spotify.android.appremote.api.Connector;
import com.spotify.android.appremote.api.SpotifyAppRemote;
import com.spotify.protocol.client.CallResult;
import com.spotify.protocol.client.ErrorCallback;
import com.spotify.protocol.client.Result;
import com.spotify.protocol.client.Subscription;
import com.spotify.protocol.types.Empty;
import com.spotify.protocol.types.PlayerState;
import com.spotify.protocol.types.Track;
import com.spotify.sdk.android.authentication.AuthenticationClient;
import com.spotify.sdk.android.authentication.AuthenticationRequest;
import com.spotify.sdk.android.authentication.AuthenticationResponse;

import java.util.concurrent.TimeUnit;

import static com.spotify.sdk.android.authentication.LoginActivity.REQUEST_CODE;

public class SpotifyClass {

    public static final String CLIENT_ID = "3e5fe6fc098945ccaec377241f38d829";
    public static final String REDIRECT_URI = "https://cs2s.yorkdc.net"; // URI to application domain
    public SpotifyAppRemote mSpotifyAppRemote;

    ConnectionParams connectionParams = new ConnectionParams.Builder(CLIENT_ID).setRedirectUri(REDIRECT_URI).showAuthView(true).build();

    /*
     * takes in a spotify id (just get it straight from the database)
     * plays it
     */
    public void playSong(String id) {
        String uri = "spotify:track:" + id;

        playUri(uri);
    }

    /*
     * pauses the current spotify track
     */
    public void pauseSong() {
        mSpotifyAppRemote.getPlayerApi().pause();
    }

    /*
     * the bit that actually plays stuff
     */
    private void playUri(String uri) {
        mSpotifyAppRemote.getPlayerApi().pause();
        mSpotifyAppRemote.getPlayerApi()
                .play(uri)
                .setResultCallback(new CallResult.ResultCallback<Empty>() {
                    @Override
                    public void onResult(Empty empty) {
                        SpotifyClass.this.logMessage("Play successful");
                    }
                })
                .setErrorCallback(mErrorCallback);

    }

    /*
     * idk what the rest of these methods do really
     */
    private void subscribeToPlayerState() {
        // Subscribe to PlayerState
        mSpotifyAppRemote.getPlayerApi().subscribeToPlayerState().setEventCallback(new Subscription.EventCallback<PlayerState>() {
            public void onEvent(PlayerState playerState) {
                // See what values are in playerState, might be able to determine if it's now randomly playing?
                final Track track = playerState.track;
                if (track != null) {
                    Log.d("Testing", track.name + " by " + track.artist.name);
                    // If the track is now different, your song has finished, stop it?
                }
            }
        });
    }

    private final ErrorCallback mErrorCallback = new ErrorCallback() {
        @Override
        public void onError(Throwable throwable) {
            SpotifyClass.this.logError(throwable, "Boom!");
        }
    };

    private void logError(Throwable throwable, String msg) {
        Log.e("Testing", msg, throwable);
    }

    private void logMessage(String msg ) {
        Log.d("Testing!!", msg);
    }
}

