package com.example.soulfood_assignment2;

import android.animation.ObjectAnimator;
import android.content.Intent;
import android.support.v4.view.ViewCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;

public class homeScreen extends AppCompatActivity {

    int swipeStartX;
    int swipeEndX;
    View sideView;
    Button settingsButton;
    Button helpButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        sideView = this.findViewById(R.id.sideView);
        settingsButton = this.findViewById(R.id.buttonSettings);
        helpButton = this.findViewById(R.id.buttonHelp);
        ViewCompat.setTranslationZ(sideView, 20f); //bring sideView in front of buttons
        
        Button b = (Button)findViewById(R.id.suggestButton);
        b.setOnClickListener(new Listener());
    }

    @Override
    public boolean onTouchEvent(MotionEvent event){
        if(event.getAction() == MotionEvent.ACTION_DOWN){ //finger touches screen
            swipeStartX = (int)event.getX();
        }else if(event.getAction() == MotionEvent.ACTION_UP){ //finger leaves screen
            swipeEndX = (int)event.getX();
            int difference = swipeStartX - swipeEndX;
            if((swipeStartX <= 80) && (difference < -10)){ //swipe from left to right
                animateSwipeOut();
            }else if(difference > 20){ //swipe from right to left
                animateSwipeIn();
            }
        }
        return super.onTouchEvent(event);
    }

    public void animateSwipeOut(){ //bring sideview out
        ObjectAnimator anim = ObjectAnimator.ofFloat(sideView, "translationX", 570f);
        anim.setDuration(500);
        anim.start();
    }

    public void animateSwipeIn(){ //hide away sideview
        ObjectAnimator anim = ObjectAnimator.ofFloat(sideView, "translationX", 0f);
        anim.setDuration(500);
        anim.start();
    }

    public void buildPlaylistViewOnClick(View view) {
        Intent intent = new Intent(this, build_playlist.class);
        startActivity(intent);
    }

    public void searchPlaylistViewOnClick(View view) {
        Intent intent = new Intent(this, searchScreen.class);
        startActivity(intent);
    }

    public void settingsViewOnClick(View view) {
        Intent intent = new Intent(this, settings.class);
        startActivity(intent);
    }
}
