package com.example.soulfood_assignment2;

import android.app.Activity;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.SearchView;
import android.widget.Toast;

import java.util.AbstractList;
import java.util.ArrayList;
import java.util.Arrays;

public class searchScreen extends AppCompatActivity {

    public ListView searchResults;
    public ListView songResults;
    public ArrayAdapter<String> adapter;

    public ArrayList<String> chineseResults;
    public ArrayList<String> thaiResults;
    public ArrayList<String> indianResults;
    public ArrayList<String> japaneseResults;
    public ArrayList<String> italianResults;
    public ArrayList<String> mexicanResults;
    public ArrayList<String> frenchResults;
    public ArrayList<String> americanResults;
    public ArrayList<String> chillResults;
    public ArrayList<String> happyResults;
    public ArrayList<String> energeticResults;



    public Intent vibeView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search_screen);
        searchResults = findViewById(R.id.tagListView);
        songResults = findViewById(R.id.charleyNeedsHelp);

        ArrayList<String> searchResultsArray = new ArrayList<>();
        searchResultsArray.addAll(Arrays.asList(getResources().getStringArray(R.array.searchResultsArray)));

        adapter = new ArrayAdapter<String>(
                searchScreen.this, android.R.layout.simple_list_item_1, searchResultsArray
        );

        searchResults.setAdapter(adapter);
        searchResults.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                switch (position) {
                    case 0:
                        ChineseAsyncTask chineseAsyncTask = new ChineseAsyncTask();
                        chineseAsyncTask.execute();
                        chineseResults = chineseAsyncTask.chineseResults;
                        tagNamePage("Chinese", chineseResults);
                        break;
                    case 1:
                        tagNamePage("Thai", thaiResults);
                        break;
                    case 2:
                        IndianAsyncTask indianAsyncTask = new IndianAsyncTask();
                        indianAsyncTask.execute();
                        indianResults = indianAsyncTask.indianResults;
                        tagNamePage("Indian", indianResults);
                        break;
                    case 3:
                        JapaneseAsyncTask japaneseAsyncTask = new JapaneseAsyncTask();
                        japaneseAsyncTask.execute();
                        japaneseResults = japaneseAsyncTask.japaneseResults;
                        tagNamePage("Japanese", japaneseResults);
                        break;
                    case 4:
                        ItalianAsyncTask italianAsyncTask = new ItalianAsyncTask();
                        italianAsyncTask.execute();
                        italianResults = italianAsyncTask.italianResults;
                        tagNamePage("Italian", italianResults);
                        break;
                    case 5:
                        MexicanAsyncTask mexicanAsyncTask = new MexicanAsyncTask();
                        mexicanAsyncTask.execute();
                        mexicanResults = mexicanAsyncTask.mexicanResults;
                        tagNamePage("Mexican", mexicanResults);
                        break;
                    case 6:
                        FrenchAsyncTask frenchAsyncTask = new FrenchAsyncTask();
                        frenchAsyncTask.execute();
                        frenchResults = frenchAsyncTask.frenchResults;
                        tagNamePage("French", frenchResults);
                        break;
                    case 7:
                        AmericanAsyncTask americanAsyncTask = new AmericanAsyncTask();
                        americanAsyncTask.execute();
                        americanResults = americanAsyncTask.americanResults;
                        tagNamePage("American", americanResults);
                        break;
                    case 8:
                        ChillAsyncTask chillAsyncTask = new ChillAsyncTask();
                        chillAsyncTask.execute();
                        chillResults = chillAsyncTask.chillResults;
                        tagNamePage("Chill", chillResults);
                        break;
                    case 9:
                        HappyAsyncTask happyAsyncTask = new HappyAsyncTask();
                        happyAsyncTask.execute();
                        happyResults = happyAsyncTask.happyResults;
                        tagNamePage("Happy", happyResults);
                        break;
                    case 10:
                        EnergeticAsyncTask energeticAsyncTask = new EnergeticAsyncTask();
                        energeticAsyncTask.execute();
                        energeticResults = energeticAsyncTask.energeticResults;
                        tagNamePage("energetic", energeticResults);
                        break;
                }
            }


        });


    }

    public void tagNamePage(String tagNameMethod, ArrayList<String> results) {
        String tagView = "Songs with '" + tagNameMethod +"' Tag";
        vibeView = new Intent(searchScreen.this, swtViewScreen.class);
        vibeView.putExtra("tag_name", tagView);
        vibeView.putExtra("tag_name_selected", tagNameMethod);
        vibeView.putExtra("array_list",results);
        startActivity(vibeView);
    }

    public boolean onCreateOptionsMenu(Menu menu) {

        SearchView sv = findViewById(R.id.searchView);
        sv.setQueryHint("Search for tags");

        sv.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {

                Toast.makeText(searchScreen.this,"No tags to match this result.", Toast.LENGTH_LONG).show();
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                adapter.getFilter().filter(s);
                return false;
            }
        });

        return super.onCreateOptionsMenu(menu);

    }


}